'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _entries = require('./entries');

var _entries2 = _interopRequireDefault(_entries);

var _resolvePath = require('./utils/resolvePath');

var _resolvePath2 = _interopRequireDefault(_resolvePath);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _defaults = require('lodash/defaults');

var _defaults2 = _interopRequireDefault(_defaults);

var _or = require('./utils/or');

var _or2 = _interopRequireDefault(_or);

var _iteratee = require('lodash/iteratee');

var _iteratee2 = _interopRequireDefault(_iteratee);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RecursionBuilder = (function () {
  function RecursionBuilder() {
    var object = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var state = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    _classCallCheck(this, RecursionBuilder);

    Object.assign(this, state);

    this.object = object;

    (0, _defaults2.default)(this, {
      yieldFilter: function yieldFilter() {
        return true;
      },
      // Default will only traverse into POJOs and Arrays.
      traverseFilter: (0, _or2.default)(_isPlainObject2.default, Array.isArray),
      entryExtractor: _entries2.default
    });

    RecursionBuilder.createExtractor(this, 'keys', 0);
    RecursionBuilder.createExtractor(this, 'values', 1);
    RecursionBuilder.createExtractor(this, 'paths', 2);
    RecursionBuilder.createExtractor(this, 'parents', 3);
  }

  _createClass(RecursionBuilder, [{
    key: Symbol.iterator,
    value: regeneratorRuntime.mark(function value() {
      return regeneratorRuntime.wrap(function value$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(this.recurse(this.object), 't0', 1);

            case 1:
            case 'end':
              return _context.stop();
          }
        }
      }, value, this);
    })
  }, {
    key: 'recurse',
    value: regeneratorRuntime.mark(function recurse(object, path) {
      var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, key, value, currentPath;

      return regeneratorRuntime.wrap(function recurse$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 3;
              _iterator = this.entryExtractor(object)[Symbol.iterator]();

            case 5:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context2.next = 19;
                break;
              }

              _step$value = _slicedToArray(_step.value, 2);
              key = _step$value[0];
              value = _step$value[1];
              currentPath = (0, _resolvePath2.default)(path, key, object);

              if (!this.yieldFilter(value, key, object)) {
                _context2.next = 13;
                break;
              }

              _context2.next = 13;
              return [key, value, currentPath, object];

            case 13:

              if (this.childExtractor) {
                value = this.childExtractor(value);
              }

              if (!this.traverseFilter(value, key, object)) {
                _context2.next = 16;
                break;
              }

              return _context2.delegateYield(this.recurse(value, currentPath), 't0', 16);

            case 16:
              _iteratorNormalCompletion = true;
              _context2.next = 5;
              break;

            case 19:
              _context2.next = 25;
              break;

            case 21:
              _context2.prev = 21;
              _context2.t1 = _context2['catch'](3);
              _didIteratorError = true;
              _iteratorError = _context2.t1;

            case 25:
              _context2.prev = 25;
              _context2.prev = 26;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 28:
              _context2.prev = 28;

              if (!_didIteratorError) {
                _context2.next = 31;
                break;
              }

              throw _iteratorError;

            case 31:
              return _context2.finish(28);

            case 32:
              return _context2.finish(25);

            case 33:
            case 'end':
              return _context2.stop();
          }
        }
      }, recurse, this, [[3, 21, 25, 33], [26,, 28, 32]]);
    })
  }, {
    key: 'yield',
    value: function _yield(filter) {
      return this.clone({ yieldFilter: filter });
    }
  }, {
    key: 'traverse',
    value: function traverse(filter) {
      return this.clone({ traverseFilter: filter });
    }
  }, {
    key: 'entries',
    value: function entries(extractor) {
      return this.clone({ entryExtractor: extractor });
    }
  }, {
    key: 'extractor',
    value: function extractor(_extractor) {
      return this.clone({ childExtractor: (0, _iteratee2.default)(_extractor) });
    }
  }, {
    key: 'clone',
    value: function clone() {
      var newState = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return new RecursionBuilder(this.object, Object.assign({}, this, newState));
    }
  }], [{
    key: 'create',
    value: function create(object, state) {
      return new RecursionBuilder(object, state);
    }
  }, {
    key: 'createExtractor',
    value: function createExtractor(target, name, index) {
      Object.defineProperty(target, name, {
        enumerable: false,
        writable: true,
        configurable: true,
        value: regeneratorRuntime.mark(function extractor(object) {
          var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, results;

          return regeneratorRuntime.wrap(function extractor$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _iteratorNormalCompletion2 = true;
                  _didIteratorError2 = false;
                  _iteratorError2 = undefined;
                  _context3.prev = 3;
                  _iterator2 = this.recurse((0, _isObject2.default)(object) ? object : this.object)[Symbol.iterator]();

                case 5:
                  if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                    _context3.next = 12;
                    break;
                  }

                  results = _step2.value;
                  _context3.next = 9;
                  return results[index];

                case 9:
                  _iteratorNormalCompletion2 = true;
                  _context3.next = 5;
                  break;

                case 12:
                  _context3.next = 18;
                  break;

                case 14:
                  _context3.prev = 14;
                  _context3.t0 = _context3['catch'](3);
                  _didIteratorError2 = true;
                  _iteratorError2 = _context3.t0;

                case 18:
                  _context3.prev = 18;
                  _context3.prev = 19;

                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }

                case 21:
                  _context3.prev = 21;

                  if (!_didIteratorError2) {
                    _context3.next = 24;
                    break;
                  }

                  throw _iteratorError2;

                case 24:
                  return _context3.finish(21);

                case 25:
                  return _context3.finish(18);

                case 26:
                case 'end':
                  return _context3.stop();
              }
            }
          }, extractor, this, [[3, 14, 18, 26], [19,, 21, 25]]);
        })
      });
    }
  }]);

  return RecursionBuilder;
})();

exports.default = RecursionBuilder;